name: Run unit tests

on:
  pull_request:
  push:
    branches: [ main ]
    tags:
  workflow_dispatch:
  schedule:
    # Run every Tuesday at 03:53 UTC
    - cron: 53 3 * * 2

jobs:
  tests:
    runs-on: ${{ matrix.os }}
    strategy:
      fail-fast: false
      matrix:
        include:
          - os: macos-latest
            python-version: 3.7
            toxenv: py37-test-pytestoldest
          - os: ubuntu-latest
            python-version: 3.7
            toxenv: py37-test-pytest50
          - os: ubuntu-latest
            python-version: 3.7
            toxenv: py37-test-pytest51
          - os: windows-latest
            python-version: 3.7
            toxenv: py37-test-pytest52
          - os: windows-latest
            python-version: 3.8
            toxenv: py38-test-pytest53
          - os: ubuntu-latest
            python-version: 3.8
            toxenv: py38-test-pytest60
          - os: ubuntu-latest
            python-version: 3.9
            toxenv: py39-test-pytest61
          - os: ubuntu-latest
            python-version: '3.10'
            toxenv: py310-test-pytest71
          - os: macos-latest
            python-version: '3.11'
            toxenv: py311-test-pytest72
          - os: ubuntu-latest
            python-version: '3.11'
            toxenv: py310-test-pytest73
          - os: windows-latest
            python-version: '3.11'
            toxenv: py310-test-pytest74
          - os: macos-latest
            python-version: '3.11'
            toxenv: py311-test-pytestdev
          - os: windows-latest
            python-version: '3.11'
            toxenv: py311-test-pytestdev
          - os: ubuntu-latest
            python-version: '3.12-dev'
            toxenv: py312-test-pytestdev

    steps:
    - uses: actions/checkout@v3
      with:
        fetch-depth: 0
    - name: Set up Python ${{ matrix.python-version }}
      uses: actions/setup-python@v4
      with:
        python-version: ${{ matrix.python-version }}
    - name: Install Tox
      run: python -m pip install tox
    - name: Run Tox
      run: tox -v -e ${{ matrix.toxenv }}
